//
// Created by red on 01/12/19.
//

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "sorts.h"

void print_elements(double* arr, size_t n) {
  printf("Elements of array:\n");
  for (size_t i = 0; i < n; i++) {
    printf("%.4f ", arr[i]);
  }
  printf("\n");
}

void init_arr(double* arr, size_t n) {
  for (size_t i = 0; i < n; i++ ){
    arr[i] = (double) (rand() % (2 << 10)) / 42;
  }
}

int main() {
  srand(time(0));
  puts("Testing quicksort...");
  double* arr = calloc(10, sizeof(double));
  init_arr(arr, 10);
  print_elements(arr, 10);
  quicksort(arr, 10);
  print_elements(arr, 10);
  puts("Sorted!");

  puts("Testing shellsort...");
  init_arr(arr, 10);
  print_elements(arr, 10);
  shellsort(arr, 10);
  print_elements(arr, 10);
  puts("Sorted!");

  puts("Testing selection sort...");
  init_arr(arr, 10);
  print_elements(arr, 10);
  selectionsort(arr, 10);
  print_elements(arr, 10);
  puts("Sorted!");
}